package cn.estsh.i3plus.ext.mes.pcn.apiservice.config;

import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.mes.bean.MesDatasource;
import cn.estsh.i3plus.pojo.mes.bean.MesPcnTask;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import org.springframework.boot.autoconfigure.condition.ConditionalOnExpression;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.Configuration;
import org.springframework.util.StringUtils;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

@ConditionalOnExpression("'${mes.offline.sync.open:false}' == 'true'")
@Data
@Configuration
@ConfigurationProperties(prefix = "mes.offline.sync")
public class MesOffLineConfig {

    //离线数据源配置
    private MesDatasourceModel dataSource = new MesDatasourceModel();

    //离线数据同步JOB配置
    private MesPcnTaskModel pcnTask = new MesPcnTaskModel();

    //sql参数注入值
    private Map<String, String> sqlParameter = new HashMap<>();

    //同步sql
    private Map<String, String> sql = new HashMap<>();

    public class MesDatasourceModel extends MesDatasource implements Serializable {

        private static final long serialVersionUID = 7825562788566047534L;

        @ApiParam("主机端口")
        private String dsHostPort;

        public void setDsHostPort(String dsHostPort) {
            this.dsHostPort = dsHostPort;
            if (!StringUtils.isEmpty(this.dsHostPort)) setDsPort(Integer.valueOf(this.dsHostPort));
        }
    }

    public class MesPcnTaskModel extends MesPcnTask implements Serializable {

        private static final long serialVersionUID = -521750700257233487L;

        public MesPcnTaskModel() {
            this.isDeleted = CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue();
            this.isValid = CommonEnumUtil.IS_VAILD.VAILD.getValue();
        }
    }
}
